package com.guna.ocrlibrary.camera.util;

import android.util.SparseArray;
import com.google.android.gms.vision.Detector;
import com.google.android.gms.vision.text.TextBlock;
import com.guna.ocrlibrary.camera.GraphicOverlay;

public class OcrDetectorProcessor implements Detector.Processor<TextBlock> {
    private GraphicOverlay<OcrGraphic> mGraphicOverlay;

    public OcrDetectorProcessor(GraphicOverlay<OcrGraphic> ocrGraphicOverlay) {
        this.mGraphicOverlay = ocrGraphicOverlay;
    }

    public void receiveDetections(Detector.Detections<TextBlock> detections) {
        this.mGraphicOverlay.clear();
        SparseArray<TextBlock> items = detections.getDetectedItems();
        for (int i = 0; i < items.size(); i++) {
            this.mGraphicOverlay.add(new OcrGraphic(this.mGraphicOverlay, items.valueAt(i)));
        }
    }

    public void release() {
        this.mGraphicOverlay.clear();
    }
}
