package com.voicetextcamera.translation;

import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;

public class AsyncTranslate extends AsyncTask<Void, Void, String> {

    String ans = "";
    Context cn;
    String from;
    OnResponse onResponse;
    ProgressDialog pd;
    String query;
    String to;

    interface OnResponse {
        void GetAns(ModelAns modelAns, Boolean bool);
    }

    public AsyncTranslate(ProgressDialog pd2, String from2, String to2, String query2, OnResponse onResponse2) {
        this.onResponse = onResponse2;
        this.pd = pd2;
        this.from = from2;
        this.to = to2;
        this.query = query2;
    }

    
    public void onPreExecute() {
        super.onPreExecute();
        this.pd.show();
    }

    
    public String doInBackground(Void... voids) {
        String s;
        try {
            s = URLEncoder.encode(this.query, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            Log.e("AAA", "Emcode Err : " + e.toString());
            e.printStackTrace();
            s = "try Another";
        }
        String Base = "https://translate.googleapis.com/translate_a/single?client=gtx&sl=" + this.from + "&tl=" + this.to + "&dt=t&ie=UTF-8&ae=UTF-8&q=" + s;
        Log.e("AAA", Base);
        try {
            HttpResponse hr = new DefaultHttpClient().execute(new HttpPost(Base));
            if (hr.getStatusLine().getStatusCode() == 200) {
                Log.e("AAA", "Succcess");
                BufferedReader br = new BufferedReader(new InputStreamReader(hr.getEntity().getContent()));
                while (true) {
                    String data = br.readLine();
                    if (data == null) {
                        break;
                    }
                    this.ans += data;
                }
                Log.e("AAA", this.ans);
            } else {
                Log.e("AAA", "Not Found");
            }
        } catch (IOException e2) {
            e2.printStackTrace();
            Log.e("AAA", "");
        }
        return this.ans;
    }

    
    public void onPostExecute(String result) {
        ModelAns ms;
        super.onPostExecute(result);
        String result2 = result.replace("[", "").replace("]", "");
        this.pd.dismiss();
        Log.e("MY", result2);
        String[] ar = result2.split(",");
        if (ar.length >= 7) {
            ms = new ModelAns(ar[0], ar[1], ar[2], ar[3], ar[4], ar[5], ar[6]);
        } else {
            ms = new ModelAns(ar[0], "", "", "", "", "", "");
        }
        if (result2.length() > 0) {
            this.onResponse.GetAns(ms, true);
        } else {
            this.onResponse.GetAns(ms, false);
        }
    }

}
