package com.voicetextcamera.translation;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;

import android.view.View;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;

import com.facebook.ads.NativeAdLayout;
import com.voicetextcamera.translation.ads.AdsCommon;

import java.util.ArrayList;

import androidx.appcompat.app.AppCompatActivity;

public class MainActivity extends AppCompatActivity {
    public static ArrayList<ModelLanguage> alllang = new ArrayList<>();
    public static String[] lang;
    public static String[] lang_code = {"ar", "bn-IN", "bg", "ca", "zh_Hans", "cs", "da", "nl", "en", "et", "fr", "fil", "fi", "de", "el", "gu-IN", "ht", "he", "hi", "hu", "id", "it", "ja", "kn-IN", "km-KH", "ko", "lv", "lt", "ms", "ml-IN", "mr-IN", "ne-NP", "no", "fa", "pl", "pt", "ro", "ru", "sk", "sl", "es", "sv", "ta-IN", "te-IN", "tr", "th", "uk", "ur-IN", "vi"};
    ImageView btncamera;
    ImageView btngallry;
    ImageView btntranslter;
    ImageView btnvoice;
    Context cn = this;
    LinearLayout.LayoutParams layoutParams;
    String[] permission = {"android.permission.RECORD_AUDIO", "android.permission.READ_EXTERNAL_STORAGE", "android.permission.WRITE_EXTERNAL_STORAGE", "android.permission.CAMERA"};

    
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView((int) R.layout.activity_main);
        getWindow().setFlags(1024, 1024);


        //Reguler Banner Ads
        RelativeLayout admob_banner = (RelativeLayout) findViewById(R.id.Admob_Banner_Frame);
        LinearLayout adContainer = (LinearLayout) findViewById(R.id.banner_container);
        AdsCommon.RegulerBanner(this, admob_banner, adContainer);

        //Small Native Ads
        FrameLayout admob_small_native = (FrameLayout) findViewById(R.id.Admob_Small_Native);
        NativeAdLayout native_banner_ad_container = (NativeAdLayout) findViewById(R.id.native_banner_ad_container);
        AdsCommon.SmallNative(this, admob_small_native, native_banner_ad_container);


        lang = getResources().getStringArray(R.array.language_in);
        init();
        resize();
        MyUtils.isNetworkConnected(this.cn);
        MyUtils.checkPermission(this.cn, this.permission);
        this.btnvoice.setOnClickListener(new AllClick());
        this.btntranslter.setOnClickListener(new AllClick());
        this.btncamera.setOnClickListener(new AllClick());
        this.btngallry.setOnClickListener(new AllClick());
    }

    public static ArrayList<ModelLanguage> getAllLang() {
        if (alllang == null || alllang.size() <= 0) {
            alllang.clear();
            for (int i = 0; i < lang.length; i++) {
                alllang.add(new ModelLanguage(lang[i], lang_code[i]));
            }
        }
        return alllang;
    }

    public class AllClick implements View.OnClickListener {
        public AllClick() {
        }

        public void onClick(View v) {
            //if (MyUtils.checkPermission(MainActivity.this.cn, MainActivity.this.permission) && MyUtils.isNetworkConnected(MainActivity.this.cn)) {
                switch (v.getId()) {
                    case R.id.btncamera /*2131296298*/:
                        Intent i = new Intent(MainActivity.this.cn, MyCrop.class);
                        i.putExtra("camera", true);
                        //MainActivity.this.startActivity(i);
                        AdsCommon.InterstitialAd(MainActivity.this, i);
                        return;
                    case R.id.btngallery /*2131296302*/:
                        Intent i2 = new Intent(MainActivity.this.cn, MyCrop.class);
                        i2.putExtra("camera", false);
                        MainActivity.this.startActivity(i2);
                        //AdsCommon.InterstitialAd(MainActivity.this, i2);
                        return;
                    case R.id.btntranslater /*2131296312*/:
                        Intent i3 = new Intent(MainActivity.this.cn, TranslatePage.class);
                        i3.putExtra("which", 1);
                        //MainActivity.this.startActivity(i3);
                        AdsCommon.InterstitialAd(MainActivity.this, i3);
                        return;
                    case R.id.btnvoice /*2131296313*/:
                        Intent i4 = new Intent(MainActivity.this.cn, TranslatePage.class);
                        i4.putExtra("which", 0);
                        //MainActivity.this.startActivity(i4);
                        AdsCommon.InterstitialAd(MainActivity.this, i4);
                        return;
                    default:
                        return;
                }
            //}
        }
    }

    
    public void init() {
        this.btnvoice = (ImageView) findViewById(R.id.btnvoice);
        this.btntranslter = (ImageView) findViewById(R.id.btntranslater);
        this.btncamera = (ImageView) findViewById(R.id.btncamera);
        this.btngallry = (ImageView) findViewById(R.id.btngallery);
    }

    
    public void resize() {
        this.layoutParams = MyUtils.getParamsL(this.cn, 1045, 275);
        this.btnvoice.setLayoutParams(this.layoutParams);
        this.btntranslter.setLayoutParams(this.layoutParams);
        this.btncamera.setLayoutParams(this.layoutParams);
        this.btngallry.setLayoutParams(this.layoutParams);
        this.layoutParams = MyUtils.getParamsL(this.cn, 90, 90);
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }
}
