package com.voicetextcamera.translation;

import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.StrictMode;

import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import com.guna.ocrlibrary.OCRCapture;
import com.theartofdev.edmodo.cropper.CropImageView;
import com.voicetextcamera.translation.ads.AdsCommon;

import java.io.File;

import androidx.appcompat.app.AppCompatActivity;

public class MyCrop extends AppCompatActivity {
    private int RESULT_CAMERA = 11;
    ImageView btnback;
    ImageView btncrop;
    ImageView btnrotate;
    Context cn = this;
    CropImageView cropImageView;
    LinearLayout.LayoutParams layoutParams;
    LinearLayout laytop;
    private File mFileTemp;

    
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView((int) R.layout.my_crop);


        //Reguler Banner Ads
        RelativeLayout admob_banner = (RelativeLayout) findViewById(R.id.Admob_Banner_Frame);
        LinearLayout adContainer = (LinearLayout) findViewById(R.id.banner_container);
        AdsCommon.RegulerBanner(this, admob_banner, adContainer);


        init();
        getWindow().setFlags(1024, 1024);
        if (getIntent().getBooleanExtra("camera", false)) {
            if ("mounted".equals(Environment.getExternalStorageState())) {
                this.mFileTemp = new File(Environment.getExternalStorageDirectory(), "tmp");
            } else {
                this.mFileTemp = new File(getFilesDir(), "tmp");
            }
            StrictMode.setVmPolicy(new StrictMode.VmPolicy.Builder().build());
            Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
            intent.putExtra("output", Uri.fromFile(this.mFileTemp));
            startActivityForResult(intent, this.RESULT_CAMERA);
        } else {
            Intent i = new Intent("android.intent.action.PICK");
            i.setType("image/*");
            startActivityForResult(i, 10);
        }
        this.cropImageView.setOnCropImageCompleteListener(new CropImageView.OnCropImageCompleteListener() {
            public void onCropImageComplete(CropImageView view, CropImageView.CropResult result) {
                String text = OCRCapture.Builder(MyCrop.this).getTextFromBitmap(result.getBitmap());
                Log.e("AAA", "Text : " + text);
                if (text.length() > 0) {
                    Intent i1 = new Intent(MyCrop.this.cn, TranslatePage.class);
                    i1.putExtra("which", 3);
                    i1.putExtra("text", text);
                    MyCrop.this.startActivity(i1);
                    MyCrop.this.finish();
                    return;
                }
                MyUtils.Toast(MyCrop.this.cn, "No Text Detect...");
                MyCrop.this.finish();
            }
        });
        this.cropImageView.setOnSetImageUriCompleteListener(new CropImageView.OnSetImageUriCompleteListener() {
            public void onSetImageUriComplete(CropImageView view, Uri uri, Exception error) {
                if (error != null) {
                    Log.e("AAA", error.getLocalizedMessage());
                }
            }
        });
        this.btnrotate.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                MyCrop.this.cropImageView.rotateImage(90);
            }
        });
        this.btncrop.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                MyCrop.this.btnrotate.setEnabled(false);
                MyCrop.this.cropImageView.getCroppedImageAsync();
            }
        });
    }

    
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 10 && resultCode == -1 && data != null) {
            Uri uri = data.getData();
            Log.e("AAA", "Gal Uri : " + uri.toString());
            this.cropImageView.setImageUriAsync(uri);
        } else if (requestCode == this.RESULT_CAMERA && resultCode == -1) {
            this.cropImageView.setImageUriAsync(Uri.fromFile(this.mFileTemp));
        } else {
            MyUtils.Toast(this.cn, "Selection Cancel");
            finish();
        }
    }

    
    public void init() {
        this.btncrop = (ImageView) findViewById(R.id.btncrop);
        this.btnrotate = (ImageView) findViewById(R.id.btnrotate);
        this.cropImageView = (CropImageView) findViewById(R.id.setImage);
        this.btnback = (ImageView) findViewById(R.id.btnback);
        this.laytop = (LinearLayout) findViewById(R.id.laytop);
        resize();
        this.btnback.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                MyCrop.this.onBackPressed();
            }
        });
    }

    
    public void resize() {
        this.layoutParams = MyUtils.getParamsL(this.cn, 450, 170);
        this.btnrotate.setLayoutParams(this.layoutParams);
        this.btncrop.setLayoutParams(this.layoutParams);
        RelativeLayout.LayoutParams layoutParams2 = MyUtils.getParamsR(this.cn, 110, 110);
        layoutParams2.addRule(15);
        this.btnback.setLayoutParams(layoutParams2);
        this.laytop.setLayoutParams(MyUtils.getParamsR(this.cn, 1080, 197));
    }
}
