package com.voicetextcamera.translation;

import android.app.ProgressDialog;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.speech.tts.TextToSpeech;
import android.speech.tts.UtteranceProgressListener;

import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;

import androidx.appcompat.app.AppCompatActivity;
import com.voicetextcamera.translation.AsyncTranslate;
import com.voicetextcamera.translation.ads.AdsCommon;

public class TranslatePage extends AppCompatActivity {

    public int LANGPICK = 11;

    public int RECORD_REQUEST = 10;
    ImageView btnback;
    ImageView btncopy;
    TextView btndestlang;
    TextView btnslang;
    ImageView btnspeak;
    ImageView btnspeech;
    ImageView btnswitch;
    ImageView btntranslate;
    ImageView btnwhatsapp;
    Context cn = this;
    EditText edtip;
    int flag;
    String from = "en";
    RelativeLayout layopbox;
    LinearLayout.LayoutParams layoutParams;
    LinearLayout laytop;
    ModelLanguage ms = new ModelLanguage("English", "en");
    ModelLanguage mt = new ModelLanguage("Hindi", "hi");
    ProgressDialog pd;
    String query;
    TextView setop;
    TextView settitle;
    TextView t1;
    TextView t2;
    TextView t3;
    String to = "hi";
    TextToSpeech tts;

    
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView((int) R.layout.translate_page);
        getWindow().setFlags(1024, 1024);


        //Reguler Banner Ads
        RelativeLayout admob_banner = (RelativeLayout) findViewById(R.id.Admob_Banner_Frame);
        LinearLayout adContainer = (LinearLayout) findViewById(R.id.banner_container);
        AdsCommon.RegulerBanner(this, admob_banner, adContainer);


        init();
        inittts();
        if (Build.VERSION.SDK_INT >= 21) {
            this.tts.speak(" ", 0, (Bundle) null, "utteranceId");
        } else {
            this.tts.speak(" ", 0, (HashMap) null);
        }
        this.flag = getIntent().getIntExtra("which", 0);
        if (this.flag == 3) {
            String text = getIntent().getStringExtra("text");
            this.edtip.setText(text);
            this.edtip.setSelection(text.length());
            this.btnspeech.setVisibility(8);
            this.settitle.setText("Translator");
        } else if (this.flag == 1) {
            this.btnspeech.setVisibility(8);
            this.settitle.setText("Translator");
        }
        this.btntranslate.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (TranslatePage.this.edtip.getText().toString().length() > 0) {
                    TranslatePage.this.query = TranslatePage.this.edtip.getText().toString();
                    TranslatePage.this.query = TranslatePage.this.query.replace("\n", "");
                    TranslatePage.this.query = TranslatePage.this.query.replace(".", " ");
                    new AsyncTranslate(TranslatePage.this.pd, TranslatePage.this.from, TranslatePage.this.to, TranslatePage.this.query, new AsyncTranslate.OnResponse() {
                        public void GetAns(ModelAns modelAns, Boolean isSuccess) {
                            if (isSuccess.booleanValue()) {
                                String op = modelAns.getOp();
                                if (op.length() >= 3) {
                                    op = op.substring(1, op.length() - 1);
                                }
                                TranslatePage.this.setop.setText(op);
                                return;
                            }
                            MyUtils.Toast(TranslatePage.this.cn, "Try Again...");
                        }
                    }).execute(new Void[0]);
                    return;
                }
                TranslatePage.this.setop.setText("");
            }
        });
        this.btnspeech.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent i = new Intent("android.speech.action.RECOGNIZE_SPEECH");
                i.putExtra("android.speech.extra.LANGUAGE_MODEL", "free_form");
                i.putExtra("android.speech.extra.LANGUAGE", TranslatePage.this.from);
                i.putExtra("android.speech.extra.MAX_RESULTS", 3);
                i.putExtra("android.speech.extra.PROMPT", "Speech");
                try {
                    TranslatePage.this.startActivityForResult(i, TranslatePage.this.RECORD_REQUEST);
                } catch (ActivityNotFoundException e) {
                    Log.e("AAA", "Your device doesn't support Speech Recognition");
                }
            }
        });
        this.btnslang.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent i = new Intent(TranslatePage.this.cn, LangSelAct.class);
                i.putExtra("which", 0);
                TranslatePage.this.startActivityForResult(i, TranslatePage.this.LANGPICK);
            }
        });
        this.btndestlang.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent i = new Intent(TranslatePage.this.cn, LangSelAct.class);
                i.putExtra("which", 1);
                TranslatePage.this.startActivityForResult(i, TranslatePage.this.LANGPICK);
            }
        });
        this.btnswitch.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                TranslatePage.this.edtip.setText("");
                TranslatePage.this.setop.setText("");
                ModelLanguage tmp = TranslatePage.this.ms;
                TranslatePage.this.ms = TranslatePage.this.mt;
                TranslatePage.this.mt = tmp;
                TranslatePage.this.SetSelectedLangUage();
            }
        });
        this.btnspeak.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!TranslatePage.this.tts.isSpeaking()) {
                    int f = TranslatePage.this.tts.setLanguage(new Locale(TranslatePage.this.mt.getLang_code()));
                    if (f == -1 || f == -2) {
                        MyUtils.Toast(TranslatePage.this.cn, TranslatePage.this.mt.getLanguage() + " Language is Not Supported");
                    }
                    String text = TranslatePage.this.setop.getText().toString();
                    if (text.length() > 0) {
                        Log.e("AAA", "Speak : " + text);
                        if (Build.VERSION.SDK_INT >= 21) {
                            TranslatePage.this.tts.speak(text, 0, (Bundle) null, "utteranceId");
                        } else {
                            TranslatePage.this.tts.speak(text, 0, (HashMap) null);
                        }
                    }
                }
            }
        });
        this.btncopy.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                String txt = TranslatePage.this.setop.getText().toString();
                if (txt.length() > 0) {
                    MyUtils.copyClipboard(TranslatePage.this.cn, txt);
                }
            }
        });
        this.btnwhatsapp.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                String txt = TranslatePage.this.setop.getText().toString();
                if (txt.length() > 0) {
                    MyUtils.sharetextonWhatsApp(TranslatePage.this.cn, txt);
                }
            }
        });
        this.edtip.addTextChangedListener(new TextWatcher() {
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            public void onTextChanged(CharSequence s, int start, int before, int count) {
            }

            public void afterTextChanged(Editable s) {
                if (s.length() > 0) {
                    TranslatePage.this.setop.setText("");
                }
            }
        });
    }

    
    public void inittts() {
        this.tts = new TextToSpeech(this.cn, new TextToSpeech.OnInitListener() {
            public void onInit(int status) {
                if (status == 0) {
                    Log.e("AAA", "TTS Status : " + status);
                }
            }
        });
        this.tts.setLanguage(Locale.getDefault());
        this.tts.setOnUtteranceProgressListener(new UtteranceProgressListener() {
            public void onStart(String utteranceId) {
                Log.e("AAA", "TTS Status Start ");
            }

            public void onDone(String utteranceId) {
                Log.e("AAA", "TTS Status Done");
            }

            public void onError(String utteranceId) {
                Log.e("AAA", "TTS Status Error ");
            }
        });
    }

    
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 10 && resultCode == -1 && data != null) {
            ArrayList<String> result = data.getStringArrayListExtra("android.speech.extra.RESULTS");
            if (result != null) {
                Iterator<String> it = result.iterator();
                while (it.hasNext()) {
                    Log.e("AAA", it.next());
                }
                String ans = result.get(0);
                this.edtip.setText(ans);
                this.edtip.setSelection(ans.length());
                this.btntranslate.performClick();
                Log.e("AAA", "" + result.size());
            }
        } else if (requestCode == this.LANGPICK && resultCode == -1 && data != null) {
            ModelLanguage ml = (ModelLanguage) data.getExtras().get("lang");
            String lang = ml.getLanguage();
            String lang_code = ml.getLang_code();
            if (data.getIntExtra("which", 0) == 0) {
                this.ms = ml;
            } else {
                this.mt = ml;
            }
            SetSelectedLangUage();
            Log.e("AAA", "Selected : " + lang + " : " + lang_code);
        }
    }

    
    public void init() {
        this.edtip = (EditText) findViewById(R.id.edtip);
        this.setop = (TextView) findViewById(R.id.setop);
        this.btntranslate = (ImageView) findViewById(R.id.btntranslate);
        this.btnspeech = (ImageView) findViewById(R.id.btnspeech);
        this.btnslang = (TextView) findViewById(R.id.btnlang);
        this.btndestlang = (TextView) findViewById(R.id.btndest);
        this.btnswitch = (ImageView) findViewById(R.id.btnswitch);
        this.btnspeak = (ImageView) findViewById(R.id.btnspeak);
        this.btncopy = (ImageView) findViewById(R.id.btncopy);
        this.btnwhatsapp = (ImageView) findViewById(R.id.btnwhats);
        this.btnback = (ImageView) findViewById(R.id.btnback);
        this.pd = new ProgressDialog(this.cn);
        this.pd.setMessage("wait...");
        this.pd.setCancelable(false);
        this.settitle = (TextView) findViewById(R.id.settitle);
        this.t1 = (TextView) findViewById(R.id.t1);
        this.t2 = (TextView) findViewById(R.id.t2);
        this.t3 = (TextView) findViewById(R.id.t3);
        this.layopbox = (RelativeLayout) findViewById(R.id.layopbox);
        this.laytop = (LinearLayout) findViewById(R.id.laytop);
        resize();
    }

    
    public void resize() {
        this.layoutParams = MyUtils.getParamsL(this.cn, 330, 330);
        this.btnspeech.setLayoutParams(this.layoutParams);
        this.layoutParams = MyUtils.getParamsL(this.cn, 986, 186);
        this.edtip.setLayoutParams(this.layoutParams);
        this.layoutParams = MyUtils.getParamsL(this.cn, 1042, 562);
        this.layopbox.setLayoutParams(this.layoutParams);
        this.layoutParams = MyUtils.getParamsL(this.cn, 320, 140);
        this.btnspeak.setLayoutParams(this.layoutParams);
        this.btncopy.setLayoutParams(this.layoutParams);
        this.btnwhatsapp.setLayoutParams(this.layoutParams);
        this.layoutParams = MyUtils.getParamsL(this.cn, 436, 156);
        this.btnslang.setLayoutParams(this.layoutParams);
        this.btndestlang.setLayoutParams(this.layoutParams);
        this.layoutParams = MyUtils.getParamsL(this.cn, 100, 50);
        this.btnswitch.setLayoutParams(this.layoutParams);
        this.layoutParams = MyUtils.getParamsL(this.cn, 580, 180);
        this.btntranslate.setLayoutParams(this.layoutParams);
        this.layoutParams = MyUtils.getParamsL(this.cn, 1080, 197);
        this.laytop.setLayoutParams(this.layoutParams);
        LinearLayout.LayoutParams l = new LinearLayout.LayoutParams((this.cn.getResources().getDisplayMetrics().widthPixels * 436) / 1080, -2);
        this.t1.setLayoutParams(l);
        this.t2.setLayoutParams(l);
        this.t3.setLayoutParams(new LinearLayout.LayoutParams((this.cn.getResources().getDisplayMetrics().widthPixels * 120) / 1080, -2));
        RelativeLayout.LayoutParams layoutParams2 = MyUtils.getParamsR(this.cn, 110, 110);
        layoutParams2.addRule(15);
        this.btnback.setLayoutParams(layoutParams2);
        this.btnback.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                TranslatePage.this.onBackPressed();
            }
        });
    }

    
    public void onDestroy() {
        super.onDestroy();
        this.pd.dismiss();
    }

    
    public void SetSelectedLangUage() {
        this.from = this.ms.getLang_code();
        this.btnslang.setText(this.ms.getLanguage());
        this.to = this.mt.getLang_code();
        this.btndestlang.setText(this.mt.getLanguage());
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

}
